#
# simple test of midi package
#

console show

lappend auto_path .
package require midi 0.2

#
# check for bound MIDI out device
#
proc TestMidiOutDev {} {
	set rc [catch {set id [midi::getoutid]} msg]
	if {$rc} {
		return "$msg"
	} else {
		return "midi dev# is $id"
	}
}

# get output devices
set mididevs(out) {}
foreach device [midi::getoutdevs] {
	lappend mididevs(out) $device
}

# get input devices
set mididevs(in) {}
foreach device [midi::getindevs] {
	lappend mididevs(in) $device
}

##########################
# 1. display MIDI devices
puts "MIDI input devices:"
for {set i 0} {$i < [llength $mididevs(in)]} {incr i} {
	puts "  $i: [lindex $mididevs(in) $i]"
}
puts ""
puts "MIDI output devices:"
for {set i 0} {$i < [llength $mididevs(out)]} {incr i} {
	puts "  $i: [lindex $mididevs(out) $i]"
}
puts ""

##########################
# 2. check out midi device before connected (Error)
puts "if no device opened: [TestMidiOutDev]"

##########################
# 3. check out midi device after connected (OK)
set f [midi::openout 1]
puts "if device 1 opened: [TestMidiOutDev]"

#set m $data(rotor,fast)
#regsub -all " " $m "" m
#puts "hex: <$m>"
#puts "set: <[binary format H* $m]>"
#puts $f [binary format H* $m]
#flush $f

midi::sendshort 144 60 112
after 1000
midi::sendshort 144 60 0

close $f

button .b -text "Quit" -width 20 -command "destroy ."
pack .b -padx 20 -pady 20
